con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000  
  RX_PIN        =  30
  TX_PIN        =  31
  MODE          = %0000                                 ' see FullDuplexSerial.spin for description
  BAUD          = 115200
  i2cSCL        = 28
  i2cSDA        = 29
    
obj
  com      : "Extended_FDSerial.spin"
  i2c      : "i2cObject"
var
  
  Byte buffer[32]
  Long eepromAddress
  Byte ArrayIn[32]
  
pub Main  | x  
   com.start(TX_PIN,RX_PIN,%0000,BAUD)
   i2c.initialize(i2cSCL)
   com.rxflush 
     repeat
   
         x:=com.rx                         
         case  x
            "W" : flash
            "R" : readEEPROM  
 
PRI flash | j

eepromAddress:=0

     repeat j from 0 to 1023  
          RxArray(100,@Buffer,32) 
          
            i2c.WritePage(i2c#BootPin, i2c#EEPROM,eepromAddress, @buffer, 32)
            eepromAddress:=eepromAddress + 32
               

PRI readIt

   if i2c.ReadPage(i2c#BootPin, i2c#EEPROM, eepromAddress, @buffer, 32)

     abort ' an error occurred during the read

PRI readEEPROM  | i , c
 
     eepromAddress:=0
         repeat i from 0 to 1023 
       
              readit
             eepromAddress := eepromAddress + 32
             repeat c from 0 to 31
                  com.tx(buffer[c])
                   
PUB RxArray (ms,stringptr,element_num) : Value | ptr , temp
{{
  ******* Modified version of Martin Hebel's RXStr from Extended_FDSerial *******
  Accepts an array of byte values - Maximum set by variable ArrayIn - to be passed by reference
  Allow timeout value.
  Will accept bytes up to the number of elements of ArrayIn before passing back.
  Serial.RxArray(100,@MyArray,5)        ' read 5 bytes into an array with 100 ms timeout
  serial.str(@MyArray)          ' transmit
 }} 
    ptr:=0                            
                                                   
   repeat while  ptr < element_num
      temp :=  com.RxTime(ms)    
          if temp == -1
             ptr++
             bytefill(@ArrayIn,0,element_num)
             quit      
       ArrayIn[ptr] :=  temp   
       ptr++
                                         
   byteMove(stringptr,@Arrayin,element_num)



                            
    